<template>
    <div class="page-container">
        <div class="video-button-container">
            <VideoButton :source="'https://carti.crisp.help/en/article/enable-email-cart-abandonment-automation-1oxiee1/reader'" />
        </div>
        <ValidationObserver
            ref="obs"
        >
            <div class="edit__top">
                <Tabs
                    :items="tabs"
                    @switch="tabIndex = $event"
                />
                <div class="edit__actions">
                    <ToggleButton
                        v-if="data"
                        v-model="data.status"
                        :font-size="12"
                        class="toggle-btn"
                        :height="24"
                        :labels="true"
                        color="rgb(45, 119, 245)"
                        @change="saveReminder"
                    />
                    <Buttons
                        :items="btns"
                        @openPreviewPopup="openPreviewPopup"
                        @saveReminder="saveReminder"
                    />
                </div>
            </div>
            <div class="row">
                <component
                    :is="activeTab"
                    :data="data"
                    :picker-keys="pickerKeys"
                    class="col-12 col-xl-6"
                    @checkChanged="checkChanged"
                />
                <div
                    class="col-12 col-xl-6 "
                >
                    <AbandonedCardEmailExample
                        class="edit__preview"
                        :data="data"
                    />
                </div>
            </div>
        </ValidationObserver>
        <SendTest
            v-if="previewPopup"
            ref="test"
            :input="{placeholder: 'E-mail Address', type: 'data',}"
            :show-text="showAlertText"
            @send="sendPreview"
            @close="previewPopup = false"
        >
            <template #unsaved>
                You have unsaved changes. We will send the last saved version of the message.
            </template> 
        </SendTest>
    </div>
</template>

<script>
import TextEditorTab from "@/components/email/abandoned-cards/TextEditorTab";
import DesignEditorTab from "@/components/email/abandoned-cards/DesignEditorTab";
import AbandonedCardEmailExample from "@/components/email/abandoned-cards/AbandonedCardEmailExample";
import SandingTab from "@/components/email/abandoned-cards/SandingTab";
import reminder from "@/mixins/email/abandoned-carts.service"
import {tags} from "@/mixins/add-tags"
import VideoButton from "@/components/header/VideoButton";
import SendTest from "@/components/modals/SendTest.vue";
import Tabs from "@/components/elements/Tabs"

export default {
    name: "AbandonedTableEdit",
    components: {VideoButton, SandingTab,Tabs, AbandonedCardEmailExample, DesignEditorTab, TextEditorTab, SendTest},
    mixins: [reminder, tags],
    data: () => ({
        data: null,
        edited: null,
        oldData: null,
        tabIndex: 0,
        tabs: [
            {title: 'Text editor', component: 'text-editor-tab'},
            {title: 'Design editor', component: 'design-editor-tab'},
            {title: 'Sending', component: 'sanding-tab'}
        ],
        btns: [
            {title: 'Send Test', event: 'openPreviewPopup', class: 'light-blue-btn'},
            {title: 'Save', event: 'saveReminder', class: 'blue-btn'},
        ],
        pickerKeys: {
            body_text: false,
            button_color: false,
            button_text: false,
            header_background: false,
            header_text: false,
            highlighted_background: false,
            highlighted_text: false,
            link: false,
            title: false,
        },
        previewPopup: false,
        showAlertText: false,
        helpModalId: 'HelpModalEmailAdandonedCarts',
        headers: {
            'Content-Type': 'application/json',
        },
        emailPreview: '',
    }),
    computed: {
        activeTab() {
            return this.tabs[this.tabIndex].component
        }
    },
    created() {
        this.getItems()
    },
    methods: {
        getItems() {
            this.getById(this.$route.params.id).then(response => {
                const { data } = response
                const defaultTextBody = '#03183B'
                if(!data.colors.body_text) data.colors.body_text = defaultTextBody
                this.data = data
                this.oldData = JSON.parse(JSON.stringify(this.data))
                this.edited = this.createEditedObj(this.oldData)
                if(this.showAlertText) this.showAlertText = false
            }).catch(error => {
                console.log(error)
            })
        },
        openPreviewPopup() {
            if(!this.previewPopup) this.showAlertText = this.checkEditedItems(this.edited)
            this.previewPopup = !this.previewPopup
        },
        checkChanged(key) {
            const data = this.trackСhange(this.oldData, this.data, key)

            if(data.key) this.edited[data.key] = data.value
        },
        async sendPreview(email) {
            try {
                 await this.sendPreviewEmail(this.$route.params.id, {
                    email,
                })
                this.previewPopup = false
                this.$notify({
                    type: 'success',
                    title: 'Sent'
                })
                
            }catch (er){
               console.log(er)
               this.$refs.test.stopLoading()
            }
        },
        async saveReminder() {
            const result = await this.$refs.obs.validate();
            let valid = await this.$refs.obs
            if (result) {
                await this.save(this.$route.params.id, this.data)
                    this.$notify({
                        type: 'success',
                        title: 'Saved'
                    });
                this.getItems()
                setTimeout(() => {
                    this.$refs.obs.reset()
                }, 2000)
            } else this.getFormErrors(valid.errors)
        }
    }
}
</script>

<style scoped lang="scss">


.fade-enter-active {
    transition: opacity 1.5s;
}

.fade-leave-active {
    opacity: 0;
}

.fade-enter, .fade-leave-to {
    opacity: 0;
}

.btn {
    margin-right: 4px;
}
</style>


